"{ Package: 'jv:libllvms' }"

"{ NameSpace: Smalltalk }"

ExternalAddress subclass:#LLVMBuilder
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'LLVM-Core'
!

!LLVMBuilder class methodsFor:'instance creation'!

new
    ^ LLVM CreateBuilder

    "Created: / 07-07-2015 / 22:38:15 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!LLVMBuilder methodsFor:'accessing'!

positionAtEnd: basicBlock
    LLVM PositionBuilderAtEnd: self  _: basicBlock

    "Created: / 07-07-2015 / 22:45:49 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!LLVMBuilder methodsFor:'instructions'!

add: value1 _: value2
    ^ self add: value1 _: value2 as: ''

    "Created: / 07-07-2015 / 22:52:39 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

add:value1 _:value2 as: name
    self assert: (value1 isKindOf: LLVMValue).
    self assert: (value2 isKindOf: LLVMValue).
    self assert: name isSingleByteString.
    ^ LLVM BuildAdd: self _: value1 _: value2 _: name

    "Created: / 07-07-2015 / 22:52:39 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

ret:value1 
    self assert: (value1 isKindOf: LLVMValue).
    ^ LLVM BuildRet: self _: value1

    "Created: / 07-07-2015 / 22:55:27 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

